<?php
/*
* Plugin Name: Crew Manager
* File admin.php
* File Version 0.2Beta
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
* This is the admin screen to set plugin options.  
* It is accessible with Skipper Admin privledges
* 4/18/2018 changed time zone correction method with dropdown
**/
$crew_manager_options['time_zone'] = "America/New_York";  // force initial settings if not yet in table
$crew_manager_options['lead_time'] = 36;    // force initial settings if not yet in table
$crew_manager_options['wp_admin_hide'] = 1;    // force initial settings (hide wp admin from roster) if not yet in table
$crew_manager_options['crew_hide'] = 1;    // force initial settings (hide not available) if not yet in table
$crew_manager_options['availability_hide'] = 1;    // force initial settings (hide not available) if not yet in table
$crew_manager_options['elp_cron_trigger'] = 1;    // force initial settings for Crew Manager to trigger CRON if not yet in table
$crew_manager_options['skipper_admin'] = "";     // force initial settings if not yet in table
$crew_manager_options['skipper'] = "";     // force initial settings if not yet in table

$crew_manager_options['stop_elp_notifications'] = 1; 
if (get_option('crew_manager_settings'))$crew_manager_options = get_option('crew_manager_settings'); // forces initial variables until saved in WP
if (!$crew_manager_options['time_zone'])$crew_manager_options['time_zone'] = "America/New_York";  // force initial settings if not yet in table
if (!$crew_manager_options['lead_time'])$crew_manager_options['lead_time'] = 36;    // force initial settings if not yet in table
// if (!$crew_manager_options['skipper'])$crew_manager_options['skipper'] = 3;    // force initial settings if not yet in table
//if (!$crew_manager_options['skipper_admin'])$crew_manager_options['skipper_admin'] = 7;    // force initial settings if not yet in table
if (!$crew_manager_options['wp_admin_hide'])$crew_manager_options['wp_admin_hide'] = 1;    // force initial settings (hide wp admin from roster) if not yet in table
if (!$crew_manager_options['crew_hide'])$crew_manager_options['crew_hide'] = 1;    // force initial settings (hide not available) if not yet in table
if (!$crew_manager_options['availability_hide'])$crew_manager_options['availability_hide'] = 1;    // force initial settings (hide not available) if not yet in table
 if (!$crew_manager_options['elp_cron_trigger'])$crew_manager_options['elp_cron_trigger'] = 1;    // force initial settings for Crew Manager to trigger CRON if not yet in table
 if (!$crew_manager_options['stop_elp_notifications'])$crew_manager_options['stop_elp_notifications'] = 1;    // force initial settings for Crew Manager to trigger ELP notification emails if not yet in table

add_action('admin_menu', 'crew_manager_plugin_setup_menu'); 

function crew_manager_plugin_setup_menu(){
        add_menu_page( 'Crew Manager Plugin', 'Crew Manager', 'edit_posts', 'crew-manager', 'crew_manager_init', 'dashicons-universal-access-alt', 65 );
$parent_slug = 'crew-manager';
$page_title = 'Position Editor';
$menu_title = 'Edit Position Titles'; 
$capability = 'edit_posts'; 
$menu_slug = 'edit-positions';
$function = 'crew_manager_edit_positions_page';
    add_submenu_page($parent_slug, 'Modify Settings', 'Modify Settings', $capability, $parent_slug, '' );
    add_submenu_page($parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function );
    add_submenu_page($parent_slug, 'Manage Email Lists', 'Manage Email Lists', $capability, 'manage-email', 'crew_manager_email_list_page' );
}

/**
* Everything in this function is displayed on the crew manager admin screen
* All other functions below this are called to be executed in this 
**/
function crew_manager_init(){
        echo "<h1>Crew Manager Admin Setup</h1>";
global $crew_manager_options;

$skipper_admin = get_registered_users_dropdown($crew_manager_options['skipper_admin']);
$skipper_name = get_registered_users_dropdown($crew_manager_options['skipper']);

?>
	<table class="form-table">
    <form class="form-table" method="post" action="options.php">
        <?php settings_fields('crew_manager_group') ?>
		<tr>
			<td width="20%"><label for="crew_manager_settings[time_zone]">
                <?= __('<b>Correct Time for <br>Local Time Zone</b>', 'textdomain') ?>
                </label>
			</td>
			<td width="30%"  align="left">
				<? echo load_timezone_dropdown($crew_manager_options['time_zone']); ?><br />

				<span class="description">Select the local time zone</span>
			</td>
			<td width="45%">
			Corrects time difference between the server and local time displayed for events so no other adjustments are needed when making entries.
			</td>
			<td width="5%">
			</td>
		</tr>


		<tr>
			<td><label for="crew_manager_settings[lead_time]">
                <?= __('<b>Crew Reminder <br>Email Lead Time</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
				<b>Crew reminder email sent </b> <input type="text" name="crew_manager_settings[lead_time]" id="crew_manager_settings[lead_time]" size="2" value="<?= $crew_manager_options['lead_time'] ?>"> <b> hours before an event.</b> <br />
				<span class="description">Type number of hours in advance of event that a crew reminder email is sent.</span>
			</td>
			<td>
			Sets the number of hours prior to an event that a reminder email is sent to crew scheduled for that event.  
			</td>		</tr>
		<tr>
			<td><label for="crew_manager_settings[skipper]">
                <?= __('<b>Designate the Skipper ...<br>The Captain of the Ship!</b>', 'textdomain') ?>
                </label>
			<td>
				<? echo get_crew_dropdown($crew_manager_options['skipper'],'skipper'); ?><br />
				<span class="description">Select the Skipper from the dropdown list to grant Crew Manager Skipper Access</span>
			</td>
			<td>
			Provides Crew Manager Skipper Access via menus to enable crew management, add, edit and delete crew members, create & edit events, post results, and upload media.
			</td>
		</tr>
		<tr>
			<td><label for="crew_manager_settings[skipper_admin]">
                <?= __('<b>Designate Skipper Access for<br>an Additional Crew Member</b>', 'textdomain') ?>
                </label>
			<td>
				<? echo get_crew_dropdown($crew_manager_options['skipper_admin'],'skipper_admin'); ?><br />
				<span class="description">Select one other to designate with Skipper Access rights.</span>
			</td>
			<td>
			Provides Skipper Access for an additional crew member who may assist the Skipper with crew managment.
			</td>
		</tr>
		<tr>
			<td><label for="crew_manager_settings[wp_admin_hide]">
                <?= __('<b>Suppress Wordpress Administrator<br>Display on Crew Roster</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b>WP Admin Display on crew roster:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[wp_admin_hide]" VALUE="1" <?php checked(1, $crew_manager_options['wp_admin_hide'], true); ?>>Hide
		 <input type="radio" name="crew_manager_settings[wp_admin_hide]" VALUE="2" <?php checked(2, $crew_manager_options['wp_admin_hide'], true); ?>>Show<br />
				<span class="description">Select to hide Wordpress Administrator from Crew Roster using radio buttons.</span>
			</td>
			<td>
			Using the <em>Hide</em> or <em>Show</em> options, the Wordpress Administrator may be removed from display on the Crew Roster.  This is handy if the WP Admin is not a crew member, or if the WP Admin is a member with a seperate account to administer the crew website.
			</td>
		</tr>

		<tr>
			<td><label for="crew_manager_settings[crew_hide]">
                <?= __('<b>Suppress Display of Crew<br><em>Not Available</em> for Events</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b>Hide Crew <em>Not Available</em> on Calendar Events:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[crew_hide]" VALUE="1" <?php checked(1, $crew_manager_options['crew_hide'], true); ?>>Hide
		 <input type="radio" name="crew_manager_settings[crew_hide]" VALUE="2" <?php checked(2, $crew_manager_options['crew_hide'], true); ?>>Show<br />
		<b>Hide Crew <em>Not Available</em> on Assignments List:&nbsp;</b>
		 <input type="radio" name="crew_manager_settings[availability_hide]" VALUE="1" <?php checked(1, $crew_manager_options['availability_hide'], true); ?>>Hide
		 <input type="radio" name="crew_manager_settings[availability_hide]" VALUE="2" <?php checked(2, $crew_manager_options['availability_hide'], true); ?>>Show<br />
				<span class="description">Select to hide crew "Not Available" using radio buttons.</span>
			</td>
			<td>
			Using the <em>Hide</em> or <em>Show</em> options, "Not Available" crew may be hidden from the event list (Calendar Entries) and from <em>Crew Assignments</em> on the menu.  It is always possible to view "Not Available" status for all crew via Skipper menu items and for Crew who are logged in using <em>Crew Availability</em> on the menu. 
			</td>
			</tr>
		<tr>
			<td><label for="crew_manager_settings[elp_cron_trigger]">
                <?= __('<b>CRON trigger source for<br>Email Posts to Subscribers</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b>CRON trigger source:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[elp_cron_trigger]" VALUE="1" <?php checked(1, $crew_manager_options['elp_cron_trigger'], true); ?>>Crew Manager &nbsp;&nbsp;&nbsp;&nbsp;
		 <input type="radio" name="crew_manager_settings[elp_cron_trigger]" VALUE="2" <?php checked(2, $crew_manager_options['elp_cron_trigger'], true); ?>>CRON Task in cPanel<br />
				<span class="description">Select the method used to trigger sending Crew Event reminder emails.</span>
			</td>
			<td>
	<? 
$pluginpath = plugin_dir_path( __DIR__ );
$path = "php -f ".$pluginpath. "cron/get-eventcrew-crontask.php >/dev/null 2>&1"; ?>
			Option 1 (preferred) - <em>Crew Manager</em> plugin directly triggers <em>Email Posts to Subscribers</em> plugin.  Copy this link to setup an hourly CRON at minute 59 every hour in cPanel for <em>Crew Manager</em>: <br><input type="text" id="path" name="path" size="125" value="<? echo $path; ?>">
			Option 2 (if Option 1 doesn't work) - CRON task setup in cPanel for both <em>Crew Manager</em> and <em>Email Posts to Subscribers</em>.  Requires <em>Crew Manager</em> CRON triggered hourly and <em>Email Posts to Subscribers</em> CRON triggered 1 minute later. This requires that two CRON tasks be scheduled.<br>
		</td>
		</tr>
		<tr>
			<td><label for="crew_manager_settings['stop_elp_notifications']">
                <?= __('<b>Suppress Wordpress Administrator<br>Sent message Email notifications</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b>Admin Notification Email Preference:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[stop_elp_notifications]" VALUE="1" <?php checked(1, $crew_manager_options['stop_elp_notifications'], true); ?>>On
		 <input type="radio" name="crew_manager_settings[stop_elp_notifications]" VALUE="2" <?php checked(2, $crew_manager_options['stop_elp_notifications'], true); ?>>Off<br />
				<span class="description">Select to turn On / Off notification messages when emails are sent.</span>
			</td>
			<td>
			Using the <em>On</em> or <em>Off</em> options, the Email notifications to the administrator from the Email Posts to Subscribers plugin may be enabled.  This is good for debug, but once all is working, the notification messages may be turned off.
			</td>
		</tr>
		<tr>
			<td></td>
			<td>
        <?php do_settings_fields('crew_manager_group', 'default') ?>
        <?php do_settings_sections('crew_manager_group') ?>
        <?php submit_button( 'Save All Changes') ?>
			</td>
    </form>
		</tr>
	</table>
<?
}

/**
* This function displays the Edit Position screen as
* a submenu that is off the crew manager admin page 
**/

function crew_manager_edit_positions_page(){
echo "<h1> Rename, Delete or Add Crew Position Titles</h1>";
$text_boxes = load_position_text_boxes_admin();
?>

<form action="" method="post">

    <table width="100%"  frame="box" border="0" cellspacing="0" cellpadding="0" >
    <tr><td width="30px">&nbsp;</td> <td width="220px"><? echo $text_boxes; ?></td>
    <td width="60%">
<p><h3>These Crew Positions are displayed in a dropdown where the Skipper may designate crew member positions for an event.</h3></p>
<p><h3>The positions of <em>Not Assigned</em>, <em>Standby Crew</em> and <em>Stay Ashore</em> are available but may not be changed.</h3></p>
	<ul>
		<li>-- <em>Not Assigned</em> is default for crew not yet assigned to a position by the Skipper.  The row is color coded with a white dot / white background.</li>
		<li>-- <em>Standby Crew</em> is assigned by the Skipper for crew who may be scheduled for the event, but not yet confirmed. The crew member must verify with the Skipper the day of the event if still coded as <em>Standby Crew</em>.  The row is color coded with a yellow dot / yellow background.</li>
		<li>-- <em>Stay Ashore</em> is assigned when there are too many crew with availability set to <em>Yes</em>.  This designates a crew member who is not on the boat for the event. The row is color coded with a red dot / pink background.</li>
		<li>-- Any crew member who has indicated <em>Yes</em> for availability and is assigned a position by the Skipper designates a crew member confirmed for the event. The row is color coded with a green dot / green background, unless assigned the position of <em>Standby Crew</em> or <em>Stay Ashore</em>.</li>
		<li>-- Any crew member who has indicated <em>Maybe</em> for availability and is assigned a position by the Skipper designates a crew member as possible for the event. The row is color coded with a yellow dot / yellow background.  If the individual changes availability to <em>Yes</em> the 
position is confirmed and the row is color coded with a green dot / green background.</li>

	</ul>
<p>&nbsp;</p>
<p><h4>To modify a position, edit the text in the box.</h4></p>
<p><h4>To delete a position, check the box next to it.  Note - Any crew member assigned that position will need to be reassigned.</h4></p>
<p><h4>To add a positon, type text in the box at the bottom.</h4></p>
<p><h4>Click <em> Submit Position Updates</em> to save changes.</h4></p>
<br><input type="submit" name="submit_positions" value="Submit Position Updates" style="font-size:10pt;color:white;
background-color:#1B8CB8;border:1px solid #054A83;padding:5px;<font color='"White"'/>
</td><td width="5%"></td></tr>

</form>
<?php
// add routine to process position updates here
if(isset($_POST['submit_positions'])){
// echo "process position updates clicked<br><br>"; //debug
if($_POST['newposition']!=""){
$newposition=$_POST['newposition'];
// echo "<br>New Position Process for ".$newposition."<br>"; //debug
global $wpdb;  // setup query to insert new position
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
    $wpdb->insert($table_crewmgr_position, array(
        'position_id' => '',
        'position' => $newposition,
        'display_order' => '10'
    ));
}// end processing new position
$position = $_POST['position'];  //sets up array with all dropdown values
$delete = $_POST['delete'];  //sets up array with all dropdown values

global $wpdb;
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
$query = $wpdb->get_results("SELECT * FROM $table_crewmgr_position 
					ORDER BY position", ARRAY_A);
foreach($query as $myrow)
	{
	  if ($myrow["position"]!= "Not Assigned" && $myrow["position"]!=  "Stay Ashore" && $myrow["position"]!= "Standby Crew" && $myrow["position"] != $newposition) { 
// exclude these from editing
		if ($myrow["position"]!=$position[$myrow["position_id"]]) {
	$new_position = $position[$myrow["position_id"]];
	$old_position = $myrow["position"];
	$position_id = $myrow["position_id"];
//  echo $old_position. " is now " . $new_position." position_id: ".$position_id."<br>";  // debug

global $wpdb;
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
        $wpdb->query("UPDATE $table_crewmgr_position SET position='$new_position' WHERE position_id = '$position_id'");
		   } // endif comparing changes 
//   		 echo $myrow["position"]. " is unchanged<br>"; // debug
// delete routine here
if ($delete[$myrow["position_id"]]==1){
	$position_id = $myrow["position_id"];
// echo "<br><br>final delete: ".$myrow[position]. "  position_id: ". $position_id; // debug

global $wpdb;
 $wpdb->query("DELETE  FROM $table_crewmgr_position WHERE position_id = '$position_id'");
	  } // endif delete check editing
	  } // endif exclude editing
	} // end foreach $query
     echo "<h1><font color=\"red\"><center>Refreshing Display</center></font></h1>";

echo "<meta http-equiv='refresh' content='0'>"; 
} // end processing submit
?>
			</td>
		</tr>
	</table>
<?
} // end function crew_manager_edit_positions_page 

/**
* This function displays the Email list management screen as
* a submenu that is off the crew manager admin page 
**/

function crew_manager_email_list_page(){
echo "<h1> Manage Email Lists</h1>";

global $crew_manager_options;
?>
	<table class="form-table">
<form action="" method="post">
		<tr>
			<td style="border-top: 6px solid #2874A6;">  <label for="email_group">
                <?= __('<b>Update Email Group for Sending<br>Posts to selected Crew Members</b>', 'textdomain') ?>
                </label>
			</td>
			<td style="border-top: 6px solid #2874A6;">
				1. Click <em>Update GetNewPosts Email Group</em> button to right <b>--></b><br>
				2. Wordpress Dashboard, mouse over <em>Email Posts</em> and click on <em>Subscribers</em><br>
				3. Use filter option (bottom right) and select <em>GetNewPosts</em><br>
				4. Delete any people who should not receive new posts via email.
			</td>
			<td style="border-top: 6px solid #2874A6;">
<input type="submit" name="submit_email_group" value="Update GetNewPosts Email Group" style="font-size:10pt;color:white;
background-color:#1B8CB8;border:1px solid #054A83;padding:5px;<font color='"White"'/>
			</td>
			<td style="border-top: 6px solid #2874A6;">
			</td>
			</tr>
			<tr><td></td><td>
<?php
// add routine to process email group here
if(isset($_POST['submit_email_group'])){
$debug="";  // Set to "Yes" to turn on debug echo displays 
$execute=load_all_crew_email($debug,"GetNewPosts");
echo "<h3>Names written to database</h3>";
// generate url path to admin's Email Posts Subscribers Page
$text = "Email Posts to Subscribers List"; 
$link = admin_url( 'admin.php?page=elp-view-subscribers');

?>
<h4>You may now delete any names from the group by clicking on this <a href="<?php echo $link;?>"><?php echo $text; ?></a> link. <br>Scroll to the bottom of the page and select the <em>GetNewPosts</em> group.</h4>
</form>
<?
} // endif POST[submit_email_group]
?>
			</td>
		</tr>
<form action="" method="post">
		<tr>
			<td style="border-top: 6px solid #2874A6;">  <label for="email_group">
                <?= __('<b>Update Email Group for Sending<br>Posts to Everyone</b>', 'textdomain') ?>
                </label>
			</td>
			<td style="border-top: 6px solid #2874A6;">
				1. Click <em>Update AllCrew Email Group</em> button to right <b>--></b><br>
				2. Wordpress Dashboard, mouse over <em>Email Posts</em> and click on <em>Subscribers</em><br>
				3. Use filter option (bottom right) and select <em>AllCrew</em><br>
				4. Delete any people who should not receive new posts via email.
			</td>
			<td style="border-top: 6px solid #2874A6;">
<input type="submit" name="submit_allcrew_email_group" value="Update AllCrew Email Group" style="font-size:10pt;color:white;
background-color:#1B8CB8;border:1px solid #054A83;padding:5px;<font color='"White"'/>
			</td>
			<td style="border-top: 6px solid #2874A6;">
			</td>
			</tr>
			<tr><td></td><td>
<?php
// add routine to process email group here
if(isset($_POST['submit_allcrew_email_group'])){
$debug="";  // Set to "Yes" to turn on debug echo displays 
$execute=load_all_crew_email($debug,"AllCrew");
echo "<h3>Names written to database</h3>";
// generate url path to admin's Email Posts Subscribers Page
$text = "Email Posts to Subscribers List"; 
$link = admin_url( 'admin.php?page=elp-view-subscribers');

?>
<h4>You may now delete any names from the group by clicking on this <a href="<?php echo $link;?>"><?php echo $text; ?></a> link. <br>Scroll to the bottom of the page and select the <em>AllCrew</em> group.</h4>
</form>
<?
} // endif POST[submit_allcrew_email_group]
?>
			</td>
		</tr>

	</table>
<?
} // end function crew_manager_email_list_page 
?>