<?php
/*
* Plugin Name: Crew Manager
* Description: A full featured sailing crew and boat management application where events are scheduled on the calendar, crew indicates availability for events, the Skipper assigns crew positions, indicates what color shirts to wear and who brings beer.  Automatic email notifications are sent to crew members 36 (or as desired) hours before an event. This requires the following plugins: "All-in-One Event Calendar by Time.ly", "User Role Editor", and "Email posts to subscribers".  The plugin "Restrict User Access" is reccomended but not required.
* Version: 0.3 (Beta Test in development)
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
* Text Domain: crew-manager
*/


/**
* Shortcodes added for Crew Management are in files located in include directory
* [crew] - displays crew lists on ai1ec events, allows setting availability if logged in
* [availablity] - Put on a page to allow logged in crew to set availability for curent year events (all events listed)
* [assignments] - Put on a page to allow logged in crew to view availability, positions & assigments by event for all crew
* [skippercrewadmin] - Put on a page similar to [availability] with ability of admin to select crew and make assignments
* [skipperassignments] - Put on a page similar to [assignments] with ability of admin to set availability, positions & assigments by event for all crew
* [results] - Put on a page to display race results ordered chronologically
* [roster] - Put on a to allow logged in crew to view crew roster on a page with name, email and phone
* additional shortcode available in the functions.php file are
* [dtg] - Prefixes "Key Event" posts with the days to go
* [cdt] - Inserts text "XX days until event" for AI1EC Key Event Posts
* [date] - displays the current date in a post

* 
**/

/**
 * Register plugin stylesheet with hook 'wp_enqueue_scripts', which can be used for front end CSS and JavaScript
 */
add_action( 'wp_enqueue_scripts', 'prefix_add_my_stylesheet' );

/**
 * Enqueue plugin style-file
 */
function prefix_add_my_stylesheet() {
    // Respects SSL, Style.css is relative to the current file
    wp_register_style( 'prefix-style', plugins_url('css/style.css', __FILE__) );
    wp_enqueue_style( 'prefix-style' );
}

define('CREWMGR_PLUGIN_URL', plugin_dir_url(__FILE__));
define('CREWMGR_PLUGIN_DIR', plugin_dir_path(__FILE__));
define('CREWMGR_PLUGIN_BASE_NAME', plugin_basename(__FILE__));
define('CREWMGR_PLUGIN_FILE', basename(__FILE__));
define('CREWMGR_PLUGIN_FULL_PATH', __FILE__);

require_once(CREWMGR_PLUGIN_DIR .'includes/loader.php');

?>