<?
/*
* Plugin Name: Crew Manager
* File assignments-shortcode.php
* File Version 0.3Beta
* Inserts [assignments] shortcode to allow logged in crew to view
* crew positions and assignments for currrent year events.
* Logged in users have dropdown for availability
* Crew Members are WP subscribers

* Crew Members are WP subscribers
* 4/28/2018 Submit button now floats
* 4/25 modified assignments-shortcode to add assignments dropdown
* for logged in users
* 4/18/2018 changed time zone correction to use date_default_timezone_set($tz)
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
**/

function content_assignments($atts, $content_assignments = null){
$debug_displays = ""; // "Yes" turns on debug displays, otherwise ""
$debug_stop_database_update  = ""; // "Yes" prevents db update, otherwise ""
$show_debug_stop_database_update = "";
$debug_email_single_admin_only  = ""; // "Yes" only emails selected admin, otherwise ""
$debug_stop_email  = ""; // "Yes" stops admin notification emails, otherwise ""
$table = ""; // start blank table
$notification_email=""; // start empty message
$hide = "";
// Reporting E_NOTICE can be good too (to report uninitialized
// variables or catch variable name misspellings ...)
error_reporting(E_ALL & ~E_NOTICE);
// error_reporting(0);

if($debug_displays) $show_debug_displays = "Debug Displays Enabled";
if($debug_stop_database_update) $show_debug_stop_database_update = "Database Updates Inhibited";
global $crew_manager_options; // allows setup options from admin panel
if($debug_email_single_admin_only) {
  $show_debug_email_single_admin_only = "Emails only going to 1 Admin User";
  $crew_administrators = get_user_email($crew_manager_options['skipper']); // single admin emails for debug
}
if ($debug_email_single_admin_only || $debug_displays || $debug_stop_database_update)$table .= "<h3>".$show_debug_displays . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;". $show_debug_email_single_admin_only . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;". $show_debug_stop_database_update ."</h3><br>";
$crew_administrators = get_user_email($crew_manager_options['skipper']); // admin for email notification if defined in admin panel
if (get_user_email($crew_manager_options['skipper_admin'])) $crew_administrators .=", ". get_user_email($crew_manager_options['skipper_admin']); // adds second admin for email notification if defined in admin panel

$current_user = wp_get_current_user(); // gets user logged in
$cur_yr = date('Y'); // gets curent year for query
$table_bgcolor="#EAF2F8"; // light blue background on selected table rows

// Get the data from the ai1ec_events table in the Wordpress database.
global $wpdb;
    $table_ai1ec_events  = $wpdb->prefix."ai1ec_events";
    $table_ai1ec_instances  = $wpdb->prefix."ai1ec_event_instances";
    $table_crewmgr_assigned  = $wpdb->prefix."crewmgr_assigned";
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
    $table_users  = $wpdb->prefix."users";
    $table_posts  = $wpdb->prefix."posts";

$user_info = get_userdata($current_user->ID);
        $user_firstname = $user_info->first_name;
        $user_lastname = $user_info->last_name;
        $user_login = $user_info->user_login;
        $selected_user_id = $current_user->ID;


$eventquery = $wpdb->get_results("SELECT DISTINCT e.start 'Start', e.end 'End', e.venue 'Location', p.post_title 'Event', p.ID 'PostID' FROM $table_ai1ec_events e, $table_ai1ec_instances i, $table_posts p 
WHERE e.post_id = p.ID
AND e.post_id = i.post_id
AND p.post_status = 'publish'
AND FROM_UNIXTIME(e.start, '%Y') = $cur_yr
ORDER BY e.start
", ARRAY_A);

    $table ="<form action=\"\" method=\"post\">";
    $table .="<b>Crew Member Logged in: </b>".$user_login."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  <b>User ID: </b>".$selected_user_id."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; (".$user_firstname  ." ".$user_lastname.")"; // update this for selected
    $table .="<table width=\"100%\"  frame=\"box\" border=\"1\" cellspacing=\"0\" cellpadding=\"0\" >";
    $table .= "<td colspan=\"7\"><center><b>Change availability for events - Choose <em>Availabile</em> dropdown for events you want to change => Scroll to bottom => Click <em>Submit Changes</em></b></center></td>";

    $table .= "<tr class=\"border_bottom\"><td colspan=\"7\"><b>Crew Color Codes:</b> Green crew is confirmed. Yellow crew need to verify with Skipper.  Red does not crew for event.  White crew position assignment not made yet.</td></tr>";
foreach($eventquery as $row)
{
    // display each $row from eventquery here.
$uniform_display = $registered_display = $fees_paid_display = $results_display = ""; //clear all display variables
$registered = get_post_meta($row['PostID'], 'registered', false);
if($registered) $registered_display=$registered[0]; //display registered status if set as meta for post
$fees_paid = get_post_meta($row['PostID'], 'fees_paid', false);
if($fees_paid) $fees_paid_display=$fees_paid[0]; //display fees paid status if set as meta for post
$uniform = get_post_meta($row['PostID'], 'uniform', false);
if($uniform) $uniform_display=$uniform[0]."<br>"; //display uniform if set as meta for post
$race_results = get_post_meta($row['PostID'], 'race_results', false);
$race_results_link = get_post_meta($row['PostID'], 'race_results_link', false);
if($race_results) $results_display=$race_results[0]; //format results as text if set in meta for post
$results_formatted_link='<a href="'.$race_results_link[0].'" target=\"_blank\">'.$race_results[0].'</a>';
if($race_results && $race_results_link) $results_display=$results_formatted_link; //format results as a link for post
global $crew_manager_options; // allows global [time_offset] and [availability_hide] in query
$tz = $crew_manager_options['time_zone'];
date_default_timezone_set($tz); //Corrects for local
     $event_date=date("D, M jS", $row['Start']);
     $event_time=date("g:i A", $row['Start']);
     $Event_URL='<a href="'.get_permalink( $row['PostID'] ).'">'.get_the_title( $row['PostID'] ).'</a>';
    $table .= "<tr style=\"background-color:".$table_bgcolor.";\"  ><td width=\"20%\"><b>Event</b></td> <td width=\"18%\"><b>Date</b></td> <td width=\"20%\"><b>Location</b></td> <td width=\"10%\"><b>Uniform</b></td> <td width=\"6%\"><b>Registered</b></td> <td width=\"6%\"><b>Fees Paid</b></td> <td><b>Results</b></td></tr>";
     $table .= "<tr><td>". $Event_URL . "</td><td>". $event_date . " " . $event_time . "</td><td>". $row['Location'] . "</td><td>". $uniform_display . "</td><td>".$registered_display."</td><td>".$fees_paid_display."</td><td>".$results_display."</td></tr>";
global $crew_manager_options; // allows global [availability_hide] in query
if ($crew_manager_options['availability_hide']==1)  $hide="AND cma.available !=3";
$crewquery = $wpdb->get_results("SELECT u.display_name 'Name', u.ID 'ID', cmp.position 'Position', cmp.position_id 'PosID', cma.available 'Available', cma.id 'AvailID', cma.assignment 'Assigned'  FROM $table_ai1ec_events e, $table_crewmgr_assigned cma, $table_crewmgr_position cmp, $table_users u  
WHERE e.post_id = $row[PostID] AND cma.ai1ec_post_id = $row[PostID]
AND cma.position_id = cmp.position_id
AND (u.ID = cma.user_ID
$hide
OR ($current_user->ID = u.ID AND u.ID = cma.user_ID AND cmp.position = 'Stay Ashore')
OR ($current_user->ID = u.ID AND u.ID = cma.user_ID AND cma.available =3)
OR ($current_user->ID = u.ID AND u.ID = cma.user_ID AND cma.available =0)
OR ($current_user->ID = u.ID AND u.ID = cma.user_ID AND cma.available =''))

ORDER BY cma.available, u.display_name
", ARRAY_A);
$all_crewquery = $wpdb->get_results("SELECT u.ID 'ID' FROM $table_users u  
", ARRAY_A);

   $table .="<tr  class=\"border_bottom\"  style=\"background-color:".$table_bgcolor.";\"><td></td><td COLSPAN=6><table width=\"100%\"  border=\"1\" cellspacing=\"0\" cellpadding=\"0\">";
    $table .= "<tr style=\"background-color:#FFFFFF;\"><td width=\"20%\"><b>Name</b></td><td align = \"center\" width=\"12%\"><b>Available</b></td> <td width=\"20%\"><b>Position</b></td>  <td><b>Assignment</b></td></tr>";

$yes_count=0;
$maybe_count=0;
$add_crew_row = 1;

foreach($crewquery as $row_crew)
{
$selected_user_id=$row_crew['ID'];
// $add_crew_row = 1;
  $pos_dropdown = load_position_dropdown($row['PostID'], $selected_user_id, $row_crew['AvailID']);
  $pos_text = load_position_text($row['PostID'], $selected_user_id, $row_crew['AvailID']);  // this is for crew display
  $position_display[$row['PostID']."-".$selected_user_id] = $pos_text; //this will be text for logged in, text box for admin
     if ($current_user->ID == $selected_user_id)   $available_dropdown = load_available_dropdown($row_crew['Available'],$row_crew['AvailID'],$selected_user_id,$row['PostID']); // dropdown for logged in users
  $available = initial_dropdown_value($row_crew['Available'], $row_crew['AvailID'], $selected_user_id, $row['PostID']);
$assignment[$row['PostID']."-".$selected_user_id] = load_assignment_text($row['Assigned'],$row['AvailID'],$selected_user_id,$row['PostID']);   // this is text for crew 
 $pos=get_position($selected_user_id, $row['PostID']);

     if($available==1) $available_display[$row['PostID']."-".$selected_user_id] ='<img src="'.plugins_url().'/crew-manager/images/checked.gif">';
     if($available=="2") $available_display[$row['PostID']."-".$selected_user_id] ='<b>?</b>';
     if($available=="3") $available_display[$row['PostID']."-".$selected_user_id] ='<img src="'.plugins_url().'/crew-manager/images/unchecked.gif">';
     if ($current_user->ID == $selected_user_id) {  $available_display[$row['PostID']."-".$selected_user_id] = $available_dropdown; // for logged in user replaces checkmarks with dropdown
$add_crew_row = 0;
} // endif ($current_user->ID == $selected_user_id)    

     $bgcolor="#ffffff"; // white  
     if($available=="3" || $pos=="Stay Ashore") $bgcolor="#ffccff"; // pink  
     if($available=="1" && $pos=="Standby Crew") $bgcolor="#ffff99"; // yellow  
     if($available=="2") $bgcolor="#ffff99"; // yellow
     if($available=="1" && ($pos!="Not Assigned" && $pos!="Standby Crew")) $bgcolor="#C2FFC2"; // green
     if(($available=="1" || $available=="2") && $pos=="Not Assigned") $bgcolor="#ffffff"; // white
     if($pos=="Stay Ashore") $bgcolor="#ffccff"; // pink
if ($bgcolor=="#C2FFC2")++$yes_count; // increments for yes (green)
if ($bgcolor=="#ffff99")++$maybe_count; // increments for maybe (yellow)
if ($bgcolor=="#ffffff")++$maybe_count; // increments for maybe (white)

$user_info = get_userdata($selected_user_id);
        $user_firstname = $user_info->first_name;
        $user_lastname = $user_info->last_name;
        $user_login = $user_info->user_login;
    $table .= "\n<tr><td bgcolor=$bgcolor>". $user_firstname." ".$user_lastname . "</td><td bgcolor=$bgcolor align = \"center\">".$available_display[$row['PostID']."-".$selected_user_id]."</td><td bgcolor=$bgcolor>" . $position_display[$row['PostID'] . "-".$selected_user_id]."</td><td bgcolor=$bgcolor>".$assignment[$row['PostID']."-".$selected_user_id]."</td></tr>"; 
} // this is end of foreach crewquery
// check $add_crew_row, if not set but logged in add a row
if ($add_crew_row==1){
$user_info = get_userdata($current_user->ID);
        $user_firstname = $user_info->first_name;
        $user_lastname = $user_info->last_name;
        $user_login = $user_info->user_login;
$pos_value = $row['Position'];
$assign_value = $row['Assigned'];
$bgcolor="#ffffff"; // white
$colordot="<span class=\"whitedot\"></span>";
$available_display[$row['PostID']."-".$selected_user_id] = load_available_dropdown(0,0,$current_user->ID,$row['PostID']);
    $table .= "\n<tr><td bgcolor=$bgcolor>". $user_firstname." ".$user_lastname . "</td><td bgcolor=$bgcolor align = \"center\">".$available_display[$row['PostID']."-".$selected_user_id]."</td><td bgcolor=$bgcolor>" . "Not Assigned" ."</td><td bgcolor=$bgcolor>". " " ."</td></tr>"; 
} // end if check logged in and row already shown

$total_count = $yes_count + $maybe_count;
    $table .="<td colspan=\"4\" align=\"center\"><b>Total Crew </b>".$total_count ."<b> = Confirmed (</b>".$yes_count."<b>) + Maybe (</b>".$maybe_count."<b>)</b></td>";

    $table .="</td></td></tr></table>";
} // this is end of foreach eventquery
    $table .="</table>";

/** Below starts the submit button  **/
    $table .="<div class=\"floatingbox\" id=\"floatingbox\"><input type=\"submit\" name=\"Submit\" value=\"Submit Changes\"</div>"; // button floats
//    $table .="<TD><font color=\"#FFFFFF\"><center><b><input type=\"submit\" name=\"Submit\" value=\"Submit Changes\"></b></center></font></TD>"; // previous fixed button
    $table .="</form>";
// below checks if availability was changed which forces a database update
if(isset($_POST['available'])){
$available = $_POST['available'];  //sets up array with all dropdown values
$avail_update=array_values($_POST['available'])[0]; // forces 1st value of array
foreach($all_crewquery as $row_crew)
{
$UserID=$row_crew['ID'];
foreach($eventquery as $row)
{
$PostID = $row['PostID'];
	$stored_avail_value = get_available_value($UserID, $PostID);
	if (!$stored_avail_value) $stored_avail_value = 0; // corrects for null value

	$avail_value = $available[$PostID."-".$UserID];

	if ($stored_avail_value != $avail_value && $UserID == $current_user->ID) { // checks if an update was made and processes, otherwise skip
	$stored_pos_value=get_position_id($UserID, $PostID);
	$stored_assign_value=get_assigned_text($UserID, $PostID);
	$stored_avail_value = get_available_value($UserID, $PostID);
	$pos_value=get_position_id($UserID, $PostID);
	$assign_value=get_assigned_text($UserID, $PostID);
 
if ($debug_displays) echo "Post ID: ".$PostID."   selected_user_id: ". $UserID. "  avail_value: ". $avail_value . " stored avail value: " . $stored_avail_value ." pos_value: ". $pos_value . "  stored position: ". $stored_pos_value." assign_value: ". $assign_value . "  stored assignment: ". $stored_assign_value. "  add_crew_row: ". $add_crew_row."<br>"; // debug display

if (!$debug_stop_database_update) $db_update =  availability_insert_or_update( $PostID, $UserID,  $avail_value, $pos_value, $assign_value); // comment out for debug
$notification_email .=$current_user->user_firstname  ." ". $current_user->user_lastname . " changed availability from ". get_available_text($stored_avail_value) . " to " . get_available_text($avail_value) . " for " .get_the_title( $PostID ). " scheduled ". get_event_start_date($PostID) . "\r\n";

	         } // endif ($avail_key == $pos_key && $assign_key == $pos_key)

} // event iteration
} // crew iteration
if ($debug_displays) echo "Text for email:<br>".$notification_email . "<br>"; // debug
if (!$debug_stop_email) { // debug turn off emails
if ($notification_email) wp_mail($crew_administrators, get_bloginfo() . " Crew Member Availability Change", $notification_email); // sends notification email with any availability changes
} // end if debug turn off emails

     echo "<h3><font color=\"red\"><center>Wait a few seconds while updates are processed - Refreshing Display</center></font></h3>";

if (!$debug_displays)  $table .="<meta http-equiv='refresh' content='0'>";  // comment out for debug
}
// This is the end of the submit button update section

    if($current_user->ID!=0){ // display table only if logged in
        return $table;
    }else{
    $table ="<h3>Only the Crew Members logged in can see this page</h3>";
    $table ="<h4>Crew Members - Please <a href=\"".wp_login_url( get_permalink() )."\" title=\"Login\">Login</a> to view a list of all events with crew positions and assignments.</h4>";

        return $table;
    }
}

add_shortcode('assignments', 'content_assignments');


// end of [assignments] shortcode ***************************
