<?
/*
* Plugin Name: Crew Manager
* File crew-shortcode.php
* File Version 0.3Beta
* 4/27/2018 added login button on event with redirect back to event
* 4/23/2018 added availability dropdown if not yet set but
* user is logged in
* 4/22/2018 fixed submit button not showing when logged in
* forced display of Crew assigned "Stay Ashore"
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
* Inserts [crew] shortcode to display crew lists for AI1EC Event Posts.
* It checks ae1ec table for event id and gets associated crew
* for the event from custom tables added for crew position and assignment by
* crew member - crew members are WP users
* Sends email to Skipper if anyone changes their availability
* $crew_administrators defined in admin panel
* Crew Members are WP subscribers
*/

function content_crew($atts, $content_crew = null){
$debug_displays = ""; // "Yes" turns on debug displays, otherwise ""
$debug_stop_database_update  = ""; // "Yes" prevents db update, otherwise ""
if($debug_displays) $show_debug_displays = "Debug Displays Enabled";
if($debug_stop_database_update) $show_debug_stop_database_update = "Database Updates Inhibited";

if ($debug_displays || $debug_stop_database_update)$table .= "<h3>".$show_debug_displays . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".  $show_debug_stop_database_update ."</h3><br>";
global $crew_manager_options; // allows setup options from admin panel
$crew_administrators = get_user_email($crew_manager_options['skipper']); // admin for email notification if defined in admin panel
if (!$crew_manager_options['skipper_admin']==0) $crew_administrators .=", ". get_user_email($crew_manager_options['skipper_admin']); // adds second admin for email notification if defined in admin panel

$postid = get_the_ID(); // gets the current post ID associated with the event
if(!$postid) $postid = $_SESSION['elp_post_id']; // if no post ID get the id from sending newsletter process
$current_user = wp_get_current_user(); // gets user logged in
// Get the data from the ai1ec_events table in the Wordpress database.
global $wpdb;
    $table_ai1ec_events  = $wpdb->prefix."ai1ec_events";
    $table_crewmgr_assigned  = $wpdb->prefix."crewmgr_assigned";
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
    $table_users  = $wpdb->prefix."users";
if ($crew_manager_options['crew_hide']==1) $hide="AND cma.available !=3";
$current_user = wp_get_current_user(); // gets user logged in
$logged_in_id = $current_user->ID; // this allows logged in user to change availability
$crewquery = $wpdb->get_results("SELECT u.display_name 'Name', u.ID 'ID', cmp.position 'Position', cmp.position_id 'PosID', cma.available 'Available', cma.id 'AvailID', cma.assignment 'Assigned', e.post_id 'PostID'  FROM $table_ai1ec_events e, $table_crewmgr_assigned cma, $table_crewmgr_position cmp, $table_users u  
WHERE e.post_id = $postid AND cma.ai1ec_post_id = $postid
AND cma.position_id = cmp.position_id
AND (u.ID = cma.user_ID
$hide
OR ($logged_in_id = u.ID AND u.ID = cma.user_ID AND cmp.position = 'Stay Ashore')
OR ($logged_in_id = u.ID AND u.ID = cma.user_ID AND cma.available =3)
OR ($logged_in_id = u.ID AND u.ID = cma.user_ID AND cma.available =0)
OR ($logged_in_id = u.ID AND u.ID = cma.user_ID AND cma.available =''))

ORDER BY cma.available, u.display_name
", ARRAY_A);
$table = "<br>"; // insert line before adding crew manager content
$registered = get_post_meta($postid, 'registered', false);
if($registered) $table .="<font color=\"blue\"><b>Registered:</b></font> ".$registered[0]; //display registered status if set as meta for post
$fees_paid = get_post_meta($postid, 'fees_paid', false);
if($registered && $fees_paid) $table .="<font color=\"blue\"><b>&nbsp;&nbsp;&nbsp;Fees Paid:</b></font> ".$fees_paid[0]."&nbsp;"; //display fees paid status if set as meta for post
$uniform = get_post_meta($postid, 'uniform', false);
if($uniform) $table .="&nbsp;&nbsp;&nbsp;<font color=\"blue\"><b>Uniform:</b></font> ".$uniform[0]."<br>"; //display uniform if set as meta for post
$race_results = get_post_meta($postid, 'race_results', false);
$race_results_link = get_post_meta($postid, 'race_results_link', false);
if($race_results) $results_display="<font color=\"blue\"><b>Race Results:</b></font> ".$race_results[0]."&nbsp;&nbsp;"; //format results as text if set in meta for post
$results_formatted_link='<a href="'.$race_results_link[0].'" target=\"_blank\">'.$race_results[0].'</a>';
if($race_results && $race_results_link) $results_display="<font color=\"blue\"><b>Race Results:</b></font> ".$results_formatted_link."&nbsp;&nbsp;"; //format results as a link for post
$series_results = get_post_meta($postid, 'series_results', false);
$series_results_link = get_post_meta($postid, 'series_results_link', false);
if($series_results) $series_results_display="<font color=\"blue\"><b>Series Results:</b></font> ".$series_results[0]."&nbsp;&nbsp;"; //format results as text if set in meta for post
$series_results_formatted_link='<a href="'.$series_results_link[0].'" target=\"_blank\">'.$series_results[0].'</a>';
if($series_results && $series_results_link) $series_results_display="<font color=\"blue\"><b>Series Results:</b></font> ".$series_results_formatted_link."&nbsp;&nbsp;"; //format results as a link for post
$table .= get_event_start_location($postid); // show venue and start time for email

$table .=$results_display; //display race results if available
$table .=$series_results_display; //display series results if available


    $table .="<form action=\"\" method=\"post\">";
    $table .="<table width=\"100%\"  border=\"1\" cellspacing=\"0\" cellpadding=\"0\">";
    $table .= "<td colspan=\"4\"><b>Crew Color Codes:</b> Green crew is confirmed. Yellow crew need to verify with Skipper.  Red does not crew for event.  White crew position assignment not made yet.</td>";
    $table .= "<tr><td><b>Name</b></td><td><b>Position</b></td><td width=\"20%\"><b>Assignment</b></td><td align = \"center\" width=\"15%\"><b>Available</b></td></tr>";
$yes_count=0;
$maybe_count=0;
$showsubmit=""; // clears submit button row check
foreach($crewquery as $row)
{
    // display each$row from query here.
     $bgcolor="#ffffff"; // white  
     if($row['Available']=="3" || $row['Position']=="Stay Ashore") $bgcolor="#ffccff"; // pink  
     if($row['Available']=="1" && $row['Position']=="Standby Crew") $bgcolor="#ffff99"; // yellow 
     if($row['Available']=="2") $bgcolor="#ffff99"; // yellow
     if($row['Available']=="1" && ($row['Position']!="Not Assigned" && $row['Position']!="Standby Crew")) $bgcolor="#C2FFC2"; // green
     if(($row['Available']=="1" || $row['Available']=="2") && $row['Position']=="Not Assigned") $bgcolor="#ffffff"; // white
     if($row['Position']=="Stay Ashore") $bgcolor="#ffccff"; // pink  
     if($row['Available']==1) $available='<img src="'.plugins_url().'/crew-manager/images/checked.gif">';
     if($row['Available']=="2") $available='<b>?</b>';
     if($row['Available']=="3") $available='<img src="'.plugins_url().'/crew-manager/images/unchecked.gif">';
if ($current_user->ID == $row['ID']){ $available = load_available_dropdown($row['Available'],$row['AvailID'],$current_user->ID,$row['PostID']);
$avail_index=$row['AvailID'];}
     $colordot="<span class=\"whitedot\"></span>";
     if ($bgcolor=="#ffff99") $colordot="<span class=\"yellowdot\"></span>";
     if ($bgcolor=="#ffccff") $colordot="<span class=\"pinkdot\"></span>";
     if ($bgcolor=="#C2FFC2") $colordot="<span class=\"greendot\"></span>";
    $table .= "\n<tr><td bgcolor=$bgcolor>". $row['Name'] . "</td><td bgcolor=$bgcolor>".$colordot." ".$row['Position']."</td><td bgcolor=$bgcolor>".$row['Assigned']."</td><td bgcolor=$bgcolor align = \"center\">".$available."</td></tr>";
if ($bgcolor=="#C2FFC2")++$yes_count; // increments for yes (green)
if ($bgcolor=="#ffff99")++$maybe_count; // increments for maybe (yellow)
if ($bgcolor=="#ffffff")++$maybe_count; // increments for maybe (white)
if ($current_user->ID == $row['ID']) {
$showsubmit=1;
$pos_value = $row['Position'];
$assign_value = $row['Assigned'];
} // endif current_user->ID
}
// check $showsubmit, if not set but logged in add a row
//if ($showsubmit == "" &&  $current_user->ID!=0){
if ($showsubmit == "" && $logged_in_id){
$bgcolor="#ffffff"; // white
$colordot="<span class=\"whitedot\"></span>";
$available = load_available_dropdown(0,0,$current_user->ID,$postid);

    $table .= "\n<tr><td bgcolor=$bgcolor>". $current_user->display_name . "</td><td bgcolor=$bgcolor>".$colordot." "."Not Assigned"."</td><td bgcolor=$bgcolor>".""."</td><td bgcolor=$bgcolor align = \"center\">".$available."</td></tr>";
$showsubmit=1;
} // end if check logged in and row already shown

$total_count = $yes_count + $maybe_count;
    $table .="<td colspan=\"4\" align=\"center\"><b>Total Crew </b>".$total_count ."<b> = Confirmed (</b>".$yes_count."<b>) + Maybe (</b>".$maybe_count."<b>)</b></td>";
    $table .="</table>";
if ($showsubmit) $table .="<TD><font color=\"#FFFFFF\"><center><b><input type=\"submit\" name=\"Submit\" value=\"Submit Availability Change\"></b></center></font></TD>";
$login_redirect = wp_login_url( get_permalink() ); 
if (!is_user_logged_in() ) {
$table .="<TD><font color=\"#FFFFFF\"><center><b><input type=\"submit\" name=\"submit_login\" value=\"Login to Update Availability\"></b></center></font></TD>";

    $table .="</form>";
if(isset($_POST['submit_login']))wp_redirect( $login_redirect);
}
// below checks if availability was changed which forces a database update
if(isset($_POST['available'])){
$avail_update=array_values($_POST['available'])[0]; // forces 1st value of array
//echo "<br><center><h2>Submit Clicked</h2></center><br>"; //debug
$notification_email=""; // start empty message
    $table_name  = $wpdb->prefix."crewmgr_assigned";
  $avail_stored = get_available_id($current_user->ID, $postid);
if(get_available_text($avail_stored) != get_available_text($avail_update)){ // this means no change so skip updating
$notification_email .=$current_user->user_firstname  ." ". $current_user->user_lastname . " changed availability from ". get_available_text($avail_stored) . " to " . get_available_text($avail_update) . " for " .get_the_title( $key ). " scheduled ". get_event_start_date_no_correction($postid) . "\r\n";

} //endif checking for avail change

if ($debug_displays) echo "<br><center><h2>avail_update: ".$avail_update." Post:".$postid." AvailID: ".$avail_index." User:".$current_user->ID."</h2></center><br>"; //debug

$_POST = array(); // clears post data after submit
// if (!$debug_stop_database_update)  $wpdb->query("UPDATE $table_name SET available='$avail_update' WHERE id='$avail_index'"); // old method before adding logged in crew

if ($debug_displays)  echo "postid: ".$postid."  logged in id: " . $logged_in_id . "  avail_update: ".$avail_update." pos_value: ".$pos_value."  assign_value: ".$assign_value."<br>";  // debug
if (!$debug_stop_database_update) $db_update = availability_insert_or_update($postid, $logged_in_id,  $avail_update, get_position_id_number($pos_value), $assign_value);

if ($debug_displays) echo "Text for email:<br> ".$notification_email; // debug
 if ($notification_email) wp_mail($crew_administrators, get_bloginfo() . " Crew Member Availability Change", $notification_email); // sends notification email with any availability changes

     echo "<h3><font color=\"red\"><center>Refreshing Display</center></font></h3>";
if(!$debug_displays)    $table .="<meta http-equiv='refresh' content='0'>"; // refresh page
}

    $table .="Post # ".$postid;
    if( $crewquery || $logged_in_id  ){ // display table only if there is crew or user logged in and has not set availability

        return $table;

    }else{
    $table ="Post # ".$postid;
        return $table;

    }

}

add_shortcode('crew', 'content_crew');

// end of [crew] shortcode ***************************
