<?
/*
* Plugin Name: Crew Manager
* File roster-shortcode.php
* File Version 0.2Beta
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
* Inserts [roster] shortcode to allow logged in crew to view
* all crew members including phone numbers and email
* Crew Members are WP subscribers
* 4/22/2018 changed login_name to display_name, removed ID display
*/

function content_roster($atts, $content_roster = null){
$current_user = wp_get_current_user(); // gets user logged in
$cur_yr = date('Y'); // gets curent year for query
    if($current_user->ID!=0){ // display table only if logged in
// Get the data from the ai1ec_events table in the Wordpress database.
global $wpdb;
global $crew_manager_options;
$wp_admin_hide = "";
if ($crew_manager_options['wp_admin_hide']==1)$wp_admin_hide = 1;    // force initial settings (hide wp admin from roster)
    $table_users  = $wpdb->prefix."users";
    $table_usermeta  = $wpdb->prefix."usermeta";

    $table ="<table width=\"100%\"  border=\"1\" cellspacing=\"0\" cellpadding=\"0\">";
    $table .= "<tr><td><b>Name</b></td><td><b>Display Name</b></td><td><b>Email</b></td><td><b>Phone</b></td></tr>";


 // Adjust the query arguments here if need be.
	$user_args = [
		'orderby' => 'last_name',
		'order' => 'ASC',
	];
	$user_query = new WP_User_Query( $user_args );
	$wp_users = $user_query->get_results();
		foreach( $wp_users as $wp_user ){
			$user_info = get_userdata( $wp_user->ID );
			$user_meta = get_user_meta( $wp_user->ID );
			$graphene_author_hide_email = $user_meta['graphene_author_hide_email'][0];
			$crew_mgr_admin_hide = "";
			$admin_rights = user_can( $user_info->ID, 'activate_plugins' );
			IF ($admin_rights && (int)$wp_admin_hide) $crew_mgr_admin_hide = 1;
          IF ( !$crew_mgr_admin_hide && !$graphene_author_hide_email ){

$email_link="<a class='link' href=\"mailto:".($user_info->user_email)."\">".$user_info->user_email . "</a>";

     $table .= "<tr><td>". $user_info->first_name." ".$user_info->last_name . "</td><td>". $user_info->display_name . "</td><td>". $email_link . "</td><td>". $user_info->mobile . "</td></tr>";
          } ELSE
          { // skip if admin = 1
          }
		}
    $table .="</table>";
   return $table;
    }else{  
// user not logged in
    $table ="<h4>Crew Members - Please <a href=\"".wp_login_url( get_permalink() )."\" title=\"Login\">Login</a> to view a roster of personnel with contact information.</h4>";

    return $table;
    }
}

add_shortcode('roster', 'content_roster');

// end of [roster] shortcode ***************************
